<?php

namespace FiloBlu\CustomerBlocker\Observer\Sales;

class OrderPlaceBefore extends OrderPlaceBeforeAbstract {

    /**
     * Execute observer
     *
     * @param \Magento\Framework\Event\Observer $observer
     * @return void
     */
    public function execute(
    \Magento\Framework\Event\Observer $observer
    ) {
        if ($this->_scopeConfig->isSetFlag(self::EMAIL_BLOCKER_ENABLE_CONFIG_PATH, \Magento\Store\Model\ScopeInterface::SCOPE_WEBSITE)) {
            $filtered_email_addresses = $this->loadFilter();
            if (empty($filtered_email_addresses)) {
                return $this;
            }
            $order_email = $observer->getEvent()->getOrder()->getCustomerEmail();
            foreach ($filtered_email_addresses as $filter) {
                $filter = str_replace('.', '\.', $filter);
                $filter = str_replace('+', '\+', $filter);
                $filter = str_replace('*', '(.*?)', $filter);
                $expr = '/^' . trim($filter) . '$/';
                //$expr = '/' . trim(str_replace('*', '(.*?)', str_replace('.', '\.', $filter))) . '/';
                if (preg_match($expr, $order_email)) {
                    throw new \Magento\Framework\Exception\LocalizedException(__("Sorry, your order cannot be processed."));
                }
            }
        }
    }

}
